/* qdos.c for dhrystone v2.1 - by Thierry Godefroy <godefroy@imaginet.fr> */

#include <stdio.h>
#include <qdos.h>
#include <string.h>

void t_on(void);
void t_off(void);
void t_start(void);
void t_stop(void);
int  t_count(void);

int polling_frequency = 50;

char _prog_name[]   = "Dhrystone";
char _version[24]   = "v2.1";
char _copyright[32] = "QDOS/SMS forever !";

char *_endmsg = "\n\nPress a key to exit.";

struct WINDOWDEF _condetails  = { 208, 1, 0, 7, 512, 256, 0, 0};
void (*_consetup)() = consetup_title;

#define QDOS_ID  0xD2540000
#define ARGOS_ID 0xDC010000
#define SMS2_ID  0x53324154
#define SMSQ_ID  0x534D5351

void guess_polf(void)
{
  int t0;

  printf("Guessing polling frequency, please wait...\n");

  t_on();
  _super();
  t0 = mt_rclck() + 6;
  t_start();
  while(mt_rclck() < t0) {}
  t0 = t_count();
  t_stop();
  _user();
  t_off();
  if (t0 > 330)
    polling_frequency = 60;
  if (t0 > 393)
    polling_frequency = 71;
}

void pollfreq(FILE *Ap)
{
  short sys_polf, *temp2;
  unsigned long ver, os_type, *temp;
  int i;
  char version[5]="    ", os[10];

  struct REGS in;
  struct REGS out;

  in.D0 = 0.L;
  qdos1(&in, &out);
  temp = (unsigned long *) out.A0;
  os_type = *temp;
  temp2 = (short *) (out.A0 + 0x00A8);
  sys_polf = *temp2;
  ver = out.D2;

  for(i=3; i>=0; i--) {
    version[i] = (char) ver;
    ver >>= 8;
    }

  switch (os_type) {

    case QDOS_ID:
      strcpy(os, "QDOS");
      if (version[2] > 0x32)
        strcpy(os, "Minerva");
      guess_polf();
      break;

    case ARGOS_ID:
      strcpy(os, "ARGOS");
      polling_frequency = 50;
      break;

    case SMS2_ID:
      strcpy(os, "SMS2");
      polling_frequency = (int) sys_polf;
      break;

    case SMSQ_ID:
      strcpy(os, "SMSQ(/E)");
      polling_frequency = (int) sys_polf;
      break;

    default:
      strcpy(os, "unknown !");
      guess_polf();
      break;
  }

  printf("\nOS     : %s\nVersion: %s\n\n", os, version);
  printf("Assumed polling frequency is %d Hertz.\n", polling_frequency);
  fprintf(Ap, "\nOS: %s, version: %s\n", os, version);
  fprintf(Ap, "Assumed polling frequency is %d Hertz.\n", polling_frequency);
}

double dtime(void)
{
  double t, f, r;
  int ti;

  ti= t_count();
  t = (double)ti;
  f = (double)polling_frequency;
  r = t / f;
  return(r);
}
